Условие выполнения sql-скрипта при установке обновления компонента

  • 30 Ответов
  • 961 Просмотров

0 Пользователей и 1 Гость просматривают эту тему.

*

Оффлайн AlekVolsk

Ситуация, блин..

Установлена версия компонента 1.0.0.
При накате обновления 1.1.0, для того, чтобы в базу внести необходимые для накатываемой версии изменения, кладу файлик /sql/updates/mysql/1.1.0.sql с необходимым содержимым и прописываю в xml:
Код: (xml) [Выделить]
 <update>
    <schemas>
      <schemapath type="mysql">sql/updates/mysql</schemapath>
    </schemas>
  </update>
Все нормально, все устанавливается, все работает.


Потом клиент начинает по-своему править исходники (много и через заднее место), а затем предъявлять: а чего это работать перестало...
Пытаюсь накатить последнюю обнову на уже установленный релиз, т.е. 1.1.0 на 1.1.0, и вылазит косяк.
Дело в том, что в /sql/updates/mysql/1.1.0.sql присутствует скрипт добавления полей в уже существующую таблицу:
Код: (sql) [Выделить]
ALTER TABLE `#__mytable` ADD `newcolumn` NOT NULL;который, есс-но, не выполняется, т.к. поле в таблице уже присутствует, выполнение всего sql-скрипта, есс-но, прерывается, как и вся установка компонента.

Что нужно написать в script.php, чтобы избежать ошибки? По сути, надо сделать проверку устанавливаемой версии и установленной, и если они не совпадают, то не выполнять sql. Как?
Код: (php) [Выделить]
class Com_MyComponentInstallerScript
{
  public function update($parent)
  {
    $newver = $parent->get('manifest')->version; // получили устанавливаемую версию
    $oldver = ; // а как получить установленную версию?
    // дальше-то что, екарный бабай?
  }
}

*

Оффлайн AlekVolsk

IF NOT EXISTS к ALTER TABLE неприменим, проверено.

*

Оффлайн zomby6888

Зачем это делать? В install.mysql.utf8.sql добавь этот столбец, а на серваке выполни запрос просто на добавление столбца. Других серверов ведь нету с этим компонентом? Даже если их несолько проще выполнить запрос чем писать установочный скрипт и обновлять версии на каждом.
интернет-блог: http://websiteprog.ru

*

Оффлайн AlekVolsk

Если изменю скрипт создания таблицы в install.mysql.utf8.sql, то при стандартной обнове 1.0.0=>1.1.0 эти поля не добавятся, т.к. скрипт будет проигнорирован (CREATE TABLE IF NOT EXISTS), ибо таблица уже существует.

Цитировать
Других серверов ведь нету с этим компонентом?
Кто знает ))

Нужно универсальное решение. В вышеописаннном случае вопрос решен кардинально: перезалил файлы по ftp, но ситуация может повториться, а в случае с компонентом широкого распространения - это полный писец.

*

Оффлайн zomby6888

Подобные вещи имеют смысл если ты пишешь расширение с целью распостранения и ты не знаешь у кого и где установлены старые версии твоего расширения.

Только сейчас прочитал он таки распостранен уже, компонент этот?
Вобще данные о компонентах хранится в таблице extensions в поле manifest_cache. Они там сериализованы, можешь извлечь данные с помощью JRegistry оттуда.
« Последнее редактирование: 07.03.2015, 02:14:05 от zomby6888 »
интернет-блог: http://websiteprog.ru


*

Оффлайн AlekVolsk

Вобще данные о компонентах хранится в таблице extensions в поле manifest_cache. Они там сериализованы, можешь извлечь данные с помощью JRegistry оттуда.
Ок, оттуда вытащу версию установленного компонента. А дальше-то что? Как заставить скрипт невыполняться?

Допускаю, что будет расширение функционала и потребуется очередное добавление столбцов в туже таблицу.

*

Оффлайн JLang

Ситуация, блин..

    $oldver = ; // а как получить установленную версию?
Делал так по официальным мануалам, тоже в установочном скрипте

if ( $type == 'update' ) {
                        $oldRelease = $this->getParam('version');
                        $rel = $oldRelease . ' на ' . $this->release;
                        if ( version_compare( $this->release, $oldRelease, 'le' ) ) {
                                Jerror::raiseWarning(null, 'Нет смысла обновлять версию '. $rel);
                                return false;
                        }
if (version_compare($oldRelease,'3.2.4.1','=')){
Jerror::raiseWarning(null, 'Обновление не для версии русификатора '. $oldRelease );
return false;
}
                }

*

Оффлайн AlekVolsk

Цитировать
Jerror::raiseWarning(null, 'Нет смысла обновлять версию '. $rel);
Смысл-то как раз есть, но частично, без выполнения sql, чтобы только файлы скопировать

*

Оффлайн zomby6888

так у меня метод preflight называется
интернет-блог: http://websiteprog.ru

*

Оффлайн AlekVolsk

да не важно какой, важно - как?

*

Оффлайн AlekVolsk

объект $paraent кстати во всех методах класса одинаков

*

Оффлайн zomby6888

Что непонятно? Пишешь скрипт, в методе preflight все действия, текущую версию как проще получить написали выше. Скрипт прописываешь себе в XML манифест.
А $this->getParam('version') точно выдаст установленную версию? До установки компонента? Там вроде даже класс то этот не наследует ничего. Впринципе там есть еще postflight метод.
« Последнее редактирование: 07.03.2015, 02:38:07 от zomby6888 »
интернет-блог: http://websiteprog.ru

*

Оффлайн JLang

...А $this->getParam('version') точно выдаст установленную версию? До установки компонента? Впринципе там есть еще postflight метод.
Ещё такое стоит. Перед всеми инициализациями в preflight

$jversion = new JVersion();

Блин, я дубовый насчёт мудрых кодов  ;D, но наверное тоже нужно

*

Оффлайн AlekVolsk

Да нет, не все так просто.
А если накатываемая версия будет 1.2.0? Ведь будут последовательно для каждой версии выполняться все sql-файлы, и это надо как-то блокировать.

Оговорюсь отдельно: J3.4

*

Оффлайн zomby6888

А не проще версию релиза сделать выше просто? И в ней прописать добавление столбца. Это было бы логично кстатии. Если ты обновляешь компонент то ты обновляешь его старшей версией а не текущей или младшей.
интернет-блог: http://websiteprog.ru

*

Оффлайн AlekVolsk

Иногда приходится обновлять текущей - по причинам, указанным в стартпосте. Накатываемая версия всегда равна или выше.

*

Оффлайн JLang

А если обновлять текущей, может задать условие в pre или post функции
Определить версию и выполнить если нужно
$db = JFactory::getDBO();
$db->setQuery ("UPDATE `#__mytable` SET.........");
$db->query();

*

Оффлайн fsv

AlekVolsk , эта таблица, в которую надо было добавить столбец, она изменяется (или не изменяется) только при обновлении версии?
Или и между обновлениями она может изменяться в результате работы сайта (например, добавление заказов)?
Заказать разработку:    расширения Joomla  |   интерфейсы на javascript(jQuery)  |  мобильные приложения

*

Оффлайн AlekVolsk

$this->release, $this->getParam('version') - откуда это? $this = object(Com_MyComponentInstallerScript)#164 (0) { }

А если обновлять текущей, может задать условие в pre или post функции
Определить версию и выполнить если нужно
$db = JFactory::getDBO();
$db->setQuery ("UPDATE `#__mytable` SET.........");
$db->query();
Тогда уж сразу
$query = 'alter table ...';
$db->setQuery($query)->execute();

AlekVolsk , эта таблица, в которую надо было добавить столбец, она изменяется (или не изменяется) только при обновлении версии?
Или и между обновлениями она может изменяться в результате работы сайта (например, добавление заказов)?
Еще как изменяется, но добавляемые поля будут затронуты только вновь добавляемыми записями

*

Оффлайн fsv

Цитировать
который, есс-но, не выполняется, т.к. поле в таблице уже присутствует, выполнение всего sql-скрипта, есс-но, прерывается, как и вся установка компонента.
в sql-файле проверка: есть ли уже поле -
SET @database = DATABASE();
SELECT table_name FROM information_schema.tables WHERE table_schema = @database AND table_name LIKE '%_weblinks' INTO @mytable;
IF NOT EXISTS(
    SELECT * FROM information_schema.COLUMNS
    WHERE COLUMN_NAME='title' AND TABLE_NAME=@mytable AND TABLE_SCHEMA=@database
)
THEN
    ALTER TABLE @mytable ADD `title` NOT NULL;
END IF
не проверял.
Засада может быть, если LIKE вернет больше 1 таблицы ("%_content", "%_menu"). Но с уникальными именами таблиц собственного компонента этого быть не должно, к тому же всегда можно доработать это условие.
« Последнее редактирование: 07.03.2015, 16:12:31 от fsv »
Заказать разработку:    расширения Joomla  |   интерфейсы на javascript(jQuery)  |  мобильные приложения

*

Оффлайн AlekVolsk

Решил вопрос, спс JLang за идею с запросами прямо в php-скрипте:
Код: (php) [Выделить]
 protected $oldver;
  protected $newver;

  public function update($parent)
  {
    $db = JFactory::getDbo();
    if (version_compare('1.1.0', $this->oldver) > 0) {
      $query = 'alter table ...'; // запрос на добавление полей
      $db->setQuery($query)->execute();
    }
    if (version_compare('1.2.0', $this->oldver) > 0) {
      $query = 'alter table ...'; // запрос на добавление полей
      $db->setQuery($query)->execute();
    }
  }

  public function preflight($type, $parent)
  {
    $db = JFactory::getDbo();
    $query = $db->getQuery(true);
    $query->select('manifest_cache')
      ->from('#__extensions')
      ->where('name='.$db->quote('com_mycomponent'));
    $mc = $db->setQuery($query)->loadResult();
    $mc = json_decode($mc);
    $this->oldver = $mc->version;

    $this->newver = $parent->get('manifest')->version;
  }
Из sql-файлов все запросы на добавление полей есс-но убираем.

PS: fsv, чуток опоздали, решил уже, но все равно метод опробую, спс

*

Оффлайн AlekVolsk

TABLE_SCHEMA='имяБазы' - я не знаю, как называется база у клиента

*

Оффлайн zomby6888

Честно говоря все равно так и не понял что мешает сделать версию обновления выше. Получить текущую установленную версию лучше так:
Код: (php) [Выделить]
$extension = $parent->get('extension');
$registry = new JRegistry($extension->manifest_cache);
$cur_version = $registry->get('version');

Пользуйтесь, дабы не долбить лишний раз базу запросами.
интернет-блог: http://websiteprog.ru

*

Оффлайн AlekVolsk

Честно говоря все равно так и не понял что мешает сделать версию обновления выше. Получить текущую установленную версию лучше так:
Код: (php) [Выделить]
$extension = $parent->get('extension');
$registry = new JRegistry($extension->manifest_cache);
$cur_version = $registry->get('version');

Пользуйтесь, дабы не долбить лишний раз базу запросами.
Да, работает спс )

*

Оффлайн AlekVolsk

Код: (php) [Выделить]
  protected $oldver;

  public function update($parent)
  {
    $db = JFactory::getDbo();
    if (version_compare('1.1.0', $this->oldver) > 0) {
      $query = 'alter table ...'; // запрос на добавление полей
      $db->setQuery($query)->execute();
    }
    if (version_compare('1.2.0', $this->oldver) > 0) {
      $query = 'alter table ...'; // запрос на добавление полей
      $db->setQuery($query)->execute();
    }
  }

  public function preflight($type, $parent)
  {
    $extension = $parent->get('extension');
    $registry = new JRegistry($extension->manifest_cache);
    $this->oldver = $registry->get('version');
  }
Окончательный вариант.

*

Оффлайн fsv

TABLE_SCHEMA='имяБазы' - я не знаю, как называется база у клиента
обновил выше
Заказать разработку:    расширения Joomla  |   интерфейсы на javascript(jQuery)  |  мобильные приложения

*

Оффлайн JLang

$this->release, $this->getParam('version') - откуда это?
Код: (php) [Выделить]
$extension = $parent->get('extension');
$registry = new JRegistry($extension->manifest_cache);
$cur_version = $registry->get('version');

Пользуйтесь, дабы не долбить лишний раз базу запросами.

А-аа, точно, там же ещё функция нужна к базе. Совсем забыл, пустая голова.
function getParam( $name ) {
$db = JFactory::getDbo();
$db->setQuery('SELECT manifest_cache FROM #__extensions WHERE name = "com_component"');
$manifest = json_decode( $db->loadResult(), true );
return $manifest[ $name ];
}
Спасибо, Зомби, за вариант без базы!

*

Оффлайн AlekVolsk

в sql-файле проверка: есть ли уже поле -
SET @database = DATABASE();
IF NOT EXISTS(
    SELECT * FROM information_schema.COLUMNS
    WHERE COLUMN_NAME='title' AND TABLE_NAME='ml36c_content' AND TABLE_SCHEMA=@database
)
THEN
    ALTER TABLE `ml36c_content` ADD `title` NOT NULL;
END IF;
не проверял.
Спотыкается на table_name - не подставляет префикс

*

Оффлайн AlekVolsk

Все же остановился на вышеприведенном варианте с php-скриптом: быстро и надежно